Unit AV04R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function AV04R1(var V :Array of Real; var W :Array of Real;
                N :Integer): Real;

implementation

function AV04R1(var V :Array of Real; var W :Array of Real;
                N :Integer): Real;
var
I,I1,K,K1,K11,L,N1 :Integer;
F,R :Real;
IR :Array [0..19] of Integer;
S :Array [0..19] of Real;
label
_10,_20,_30,_40,_50,_60;
begin
{ Result -    AV04R1  FORTRANe }
F  := 0.0;
K  := 1;
if ( N  =  1 ) 
 then S[0] := V[0]*W[0];
if ( N  >=  2 ) 
 then S[0] := V[0]*W[0] + V[1]*W[1];
if ( N  <=  2 ) 
 then goto _50;
I1  := 2;
IR[0] := 1;
if ( N  =  3 ) 
 then goto _40;
N1  := N - 1;
I := 3;
while ( I<=N1 ) do
 begin
  I1  := I + 1;
  R  := V[I-1]*W[I-1] + V[I1-1]*W[I1-1];
  K  := K + 1;
  S[K-1] := R;
  IR[K-1] := 1;
  K1  := K;
  for L:=2 to K do
   begin
    K11  := K1 - 1;
    if ( IR[K1-1] <>  IR[K11-1] ) 
     then goto _20;
    IR[K11-1] := IR[K11-1] + 1;
    S[K11-1] := S[K11-1] + S[K1-1];
    K1  := K11;
_10:
   end;
_20:
  K  := K1;
_30:
  inc(I,2);
 end;
_40:
if ( I1  <>  N ) 
 then F  := V[N-1]*W[N-1];
_50:
for I:=1 to K do
 begin
  F  := F + S[I-1];
_60:
 end;
Result := F;
exit;
end;

end.
